### Method

# FwupdPlugin UsbDevice get_string_descriptor_bytes_full

since: 2.0.0

#### Declaration [src]

    GBytes*
    fu_usb_device_get_string_descriptor_bytes_full (
      FuUsbDevice* self,
      guint8 desc_index,
      guint16 langid,
      gsize length,
      GError** error
    )

#### Description [src]

Get a raw string descriptor from the device. The returned string should be freed with `g_bytes_unref()` when no longer needed.

Available since: 2.0.0

#### Parameters

`desc_index`

  Type: `guint8`

  The index for the string descriptor to retrieve.

`langid`

  Type: `guint16`

  The language ID.

`length`

  Type: `gsize`

  Size of the request data buffer.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GBytes`

A possibly UTF-16 string, or NULL on error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.